The Synthesis ToolKit in C++ (STK)

Home Information Classes Download Usage Mail List Requirements Links FAQ Tutorial

Public Member Functions | List of all members
stk::Resonate Class Reference

STK noise driven formant filter. More...

`#include <Resonate.h>`

Inheritance diagram for stk::Resonate:

## Public Member Functions
| Resonate (void)
| Class constructor.
| ~Resonate (void)
| Class destructor.
void | setResonance (StkFloat frequency, StkFloat radius)
| Set the filter for a resonance at the given frequency (Hz) and radius.
void | setNotch (StkFloat frequency, StkFloat radius)
| Set the filter for a notch at the given frequency (Hz) and radius.
void | setEqualGainZeroes (void)
| Set the filter zero coefficients for contant resonance gain.
void | keyOn (void)
| Initiate the envelope with a key-on event.
void | keyOff (void)
| Signal a key-off event to the envelope.
void | noteOn (StkFloat frequency, StkFloat amplitude)
| Start a note with the given frequency and amplitude.
void | noteOff (StkFloat amplitude)
| Stop a note with the given amplitude (speed of decay).
void | controlChange (int number, StkFloat value)
| Perform the control change specified by number and value (0.0 - 128.0).
StkFloat | tick (unsigned int channel=0)
| Compute and return one output sample.
StkFrames & | tick (StkFrames &frames, unsigned int channel=0)
| Fill a channel of the StkFrames object with computed outputs.
Public Member Functions inherited from stk::Instrmnt
| Instrmnt (void)
| Class constructor.
virtual void | clear (void)
| Reset and clear all internal state (for subclasses).
virtual void | noteOn (StkFloat frequency, StkFloat amplitude)=0
| Start a note with the given frequency and amplitude.
virtual void | noteOff (StkFloat amplitude)=0
| Stop a note with the given amplitude (speed of decay).
virtual void | setFrequency (StkFloat frequency)
| Set instrument parameters for a particular frequency.
virtual void | controlChange (int number, StkFloat value)
| Perform the control change specified by number and value (0.0 - 128.0).
unsigned int | channelsOut (void) const
| Return the number of output channels for the class.
const StkFrames & | lastFrame (void) const
| Return an StkFrames reference to the last output sample frame.
StkFloat | lastOut (unsigned int channel=0)
| Return the specified channel value of the last computed frame.
virtual StkFloat | tick (unsigned int channel=0)=0
| Compute one sample frame and return the specified `channel` value.
virtual StkFrames & | tick (StkFrames &frames, unsigned int channel=0)=0
| Fill the StkFrames object with computed sample frames, starting at the specified channel.
Public Member Functions inherited from stk::Stk
void | ignoreSampleRateChange (bool ignore=true)
| A function to enable/disable the automatic updating of class data when the STK sample rate changes.

## Additional Inherited Members
Static Public Member Functions inherited from stk::Stk
static StkFloat | sampleRate (void)
| Static method that returns the current STK sample rate.
static void | setSampleRate (StkFloat rate)
| Static method that sets the STK sample rate.
static void | clear_alertList ()
| Static method that frees memory from alertList_.
static std::string | rawwavePath (void)
| Static method that returns the current rawwave path.
static void | setRawwavePath (std::string path)
| Static method that sets the STK rawwave path.
static void | swap16 (unsigned char *ptr)
| Static method that byte-swaps a 16-bit data type.
static void | swap32 (unsigned char *ptr)
| Static method that byte-swaps a 32-bit data type.
static void | swap64 (unsigned char *ptr)
| Static method that byte-swaps a 64-bit data type.
static void | sleep (unsigned long milliseconds)
| Static cross-platform method to sleep for a number of milliseconds.
static bool | inRange (StkFloat value, StkFloat min, StkFloat max)
| Static method to check whether a value is within a specified range.
static void | handleError (const char *message, StkError::Type type)
| Static function for error reporting and handling using c-strings.
static void | handleError (std::string message, StkError::Type type)
| Static function for error reporting and handling using c++ strings.
static void | showWarnings (bool status)
| Toggle display of WARNING and STATUS messages.
static void | printErrors (bool status)
| Toggle display of error messages before throwing exceptions.
Static Public Attributes inherited from stk::Stk
static const StkFormat | STK_SINT8
static const StkFormat | STK_SINT16
static const StkFormat | STK_SINT24
static const StkFormat | STK_SINT32
static const StkFormat | STK_FLOAT32
static const StkFormat | STK_FLOAT64
Protected Member Functions inherited from stk::Stk
| Stk (void)
| Default constructor.
virtual | ~Stk (void)
| Class destructor.
virtual void | sampleRateChanged (StkFloat newRate, StkFloat oldRate)
| This function should be implemented in subclasses that depend on the sample rate.
void | addSampleRateAlert (Stk *ptr)
| Add class pointer to list for sample rate change notification.
void | removeSampleRateAlert (Stk *ptr)
| Remove class pointer from list for sample rate change notification.
void | handleError (StkError::Type type) const
| Internal function for error reporting that assumes message in `oStream_` variable.

## Detailed Description

STK noise driven formant filter.

This instrument contains a noise source, which excites a biquad resonance filter, with volume controlled by an ADSR.

Control Change Numbers:

- Resonance Frequency (0-Nyquist) = 2
- Pole Radii = 4
- Notch Frequency (0-Nyquist) = 11
- Zero Radii = 1
- Envelope Gain = 128

by Perry R. Cook and Gary P. Scavone, 1995–2023.

## Member Function Documentation

## ◆ tick()

StkFrames & stk::Resonate::tick | ( | StkFrames & | frames,
|  | unsigned int | channel = `0`
| ) |  |
| inlinevirtual

Fill a channel of the StkFrames object with computed outputs.

The `channel` argument must be less than the number of channels in the StkFrames argument (the first channel is specified by 0). However, range checking is only performed if STK_DEBUG is defined during compilation, in which case an out-of-range value will trigger an StkError exception.

Implements stk::Instrmnt.

96{
97 unsigned int nChannels = lastFrame_.channels();
98#if defined(_STK_DEBUG_)
99 if ( channel > frames.channels() - nChannels ) {
100 oStream_ << "Resonate::tick(): channel and StkFrames arguments are incompatible!";
101 handleError( StkError::FUNCTION_ARGUMENT );
102 }
103#endif
104
105 StkFloat *samples = &frames[channel];
106 unsigned int j, hop = frames.channels() - nChannels;
107 if ( nChannels == 1 ) {
108 for ( unsigned int i=0; i<frames.frames(); i++, samples += hop )
109 *samples++ = tick();
110 }
111 else {
112 for ( unsigned int i=0; i<frames.frames(); i++, samples += hop ) {
113 *samples++ = tick();
114 for ( j=1; j<nChannels; j++ )
115 *samples++ = lastFrame_[j];
116 }
117 }
118
119 return frames;
120}
stk::Resonate::tick
StkFloat tick(unsigned int channel=0)
Compute and return one output sample.
Definition Resonate.h:88
stk::StkFrames::channels
unsigned int channels(void) const
Return the number of channels represented by the data.
Definition Stk.h:416
stk::Stk::handleError
static void handleError(const char *message, StkError::Type type)
Static function for error reporting and handling using c-strings.

The documentation for this class was generated from the following file:

- Resonate.h

The Synthesis ToolKit in C++ (STK)
©1995--2023 Perry R. Cook and Gary P. Scavone. All Rights Reserved.